﻿using DWZB_Agv_Agreement.Agv_Agreement;
using DWZB_Agv_Agreement.Agv_Agreement_New;
using DWZB_Agv_Agreement.EnumsLibrary;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace DWZB_Agv_Agreement.Agv_Agreement_New
{
    /// <summary>
    /// Agv指令操作通用类
    /// 复位指令、停止指令、
    /// 开启指令存储队列、暂停指令存储队列、停止指令存储队列、
    /// 删除指令存储队列的某条指令、清空指令存储队列的所有指令
    /// </summary>
    public class AgvCmdOperateMd : DataHeadMd_New
    {
        private const int btyArrLen = 10;

        /// <summary>
        /// 指令编号
        /// </summary>
        public uint CmdNo { get; set; }
        /// <summary>
        /// 指令代码
        /// </summary>
        public AgvCmdTypeEnum CmdTypeCode { get; set; }
        /// <summary>
        /// 序列化为byte数组。
        /// </summary>
        public byte[] SerializeBytArr()
        {
            List<byte> retBtArr = new(btyArrLen);
            retBtArr.Add((byte)FunctionCode);
            retBtArr.AddRange(DataHandleHelper.ReverseBtyArr(BitConverter.GetBytes(AgvNo)));
            retBtArr.AddRange(DataHandleHelper.ReverseBtyArr(BitConverter.GetBytes(CmdNo)));
            retBtArr.Add((byte)CmdTypeCode);
            return retBtArr.ToArray();
        }
    }
}
