﻿using DWZB_Agv_Agreement.Agv_Agreement;
using DWZB_Agv_Agreement.Agv_Agreement_New;
using DWZB_Agv_Agreement.EnumsLibrary;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace DWZB_Agv_Agreement.Agv_Agreement_New
{
    public class AgvMoveCmdActionMd : DataHeadMd_New
    {
        private const int btyArrLen = 42;
        /// <summary>
        /// 指令编号
        /// </summary>
        public uint CmdNo { get; set; }
        /// <summary>
        /// 指令代码
        /// </summary>
        public AgvCmdTypeEnum CmdTypeCode { get; set; }
        /// <summary>
        /// 动作类型
        /// </summary>
        public AgvCmdActionTypeEnum ActionType { get; set; }
        /// <summary>
        /// AGV移动方式
        /// </summary>
        public AgvMoveModeEnum MoveMode { get; set; }
        /// <summary>
        /// AGV移动方向
        /// </summary>
        public AgvMoveDirectionEnum MoveDirection { get; set; }
        /// <summary>
        /// 目标点RFID编号
        /// </summary>
        public uint TargetRfidNo { get; set; }
        /// <summary>
        /// 目标点X坐标
        /// </summary>
        public float X_Coordinate { get; set; }
        /// <summary>
        /// 目标点Y坐标
        /// </summary>
        public float Y_Coordinate { get; set; }
        /// <summary>
        /// 目标点角度
        /// </summary>
        public float TargetAngle { get; set; }
        /// <summary>
        /// 移动速度（%）
        /// </summary>
        public float MoveSpeed { get; set; }
        /// <summary>
        /// 序列化为byte数组。
        /// </summary>
        public byte[] SerializeBytArr()
        {
            List<byte> retBtArr = new(btyArrLen);
            retBtArr.Add((byte)FunctionCode);
            retBtArr.AddRange(DataHandleHelper.ReverseBtyArr(BitConverter.GetBytes(AgvNo)));
            retBtArr.AddRange(DataHandleHelper.ReverseBtyArr(BitConverter.GetBytes(CmdNo)));
            retBtArr.Add((byte)CmdTypeCode);
            retBtArr.Add((byte)ActionType);
            retBtArr.Add((byte)MoveMode);
            retBtArr.Add((byte)MoveDirection);
            retBtArr.AddRange(DataHandleHelper.ReverseBtyArr(BitConverter.GetBytes(TargetRfidNo)));
            retBtArr.AddRange(DataHandleHelper.ReverseBtyArr(BitConverter.GetBytes(X_Coordinate)));
            retBtArr.AddRange(DataHandleHelper.ReverseBtyArr(BitConverter.GetBytes(Y_Coordinate)));
            retBtArr.AddRange(DataHandleHelper.ReverseBtyArr(BitConverter.GetBytes(TargetAngle)));
            retBtArr.AddRange(DataHandleHelper.ReverseBtyArr(BitConverter.GetBytes(MoveSpeed)));
            return retBtArr.ToArray();
        }
    }
}
