﻿using DWZB_Agv_Agreement.Agv_Agreement;
using DWZB_Agv_Agreement.EnumsLibrary;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace DWZB_Agv_Agreement.Agv_Agreement_New
{
    public class AgvSupportCmdActionMd : DataHeadMd_New
    {
        private const int btyArrLen = 21;
        /// <summary>
        /// 指令编号
        /// </summary>
        public uint CmdNo { get; set; }
        /// <summary>
        /// 指令代码
        /// </summary>
        public AgvCmdTypeEnum CmdTypeCode { get; set; }
        /// <summary>
        /// 动作类型
        /// </summary>
        public AgvCmdActionTypeEnum ActionType { get; set; }
        /// <summary>
        /// 支撑动作
        /// </summary>
        public AgvSupportActionEnum SupportActionType { get; set; }
        /// <summary>
        /// 序列化为byte数组。
        /// </summary>
        public byte[] SerializeBytArr()
        {
            List<byte> retBtArr = new(btyArrLen);
            retBtArr.Add((byte)FunctionCode);
            retBtArr.AddRange(DataHandleHelper.ReverseBtyArr(BitConverter.GetBytes(AgvNo)));
            retBtArr.AddRange(DataHandleHelper.ReverseBtyArr(BitConverter.GetBytes(CmdNo)));
            retBtArr.Add((byte)CmdTypeCode);
            retBtArr.Add((byte)ActionType);
            retBtArr.Add((byte)SupportActionType);
            return retBtArr.ToArray();
        }
    }
}
