﻿using System.ComponentModel;

namespace DWZB_Agv_Agreement.EnumsLibrary
{
    public enum AgvCmdTypeEnum
    {
        [Description("未知")]
        未知 = 0x00,
        /// <summary>
        /// 更改运行状态
        /// </summary>
        [Description("运行状态更改")]
        运行状态更改 = 0x01,
        /// <summary>
        /// 执行一个单步动作
        /// </summary>
        [Description("单步动作")]
        单步动作 = 0x02,
        /// <summary>
        /// 单个动作作为任务中的一个储存
        /// </summary>
        [Description("任务存储")]
        任务存储 = 0x03,
        /// <summary>
        /// 修改单个AGV任务中某个动作
        /// </summary>
        [Description("修改任务")]
        修改任务 = 0x04,
        /// <summary>
        /// 删除AGV任务中某个动作
        /// </summary>
        [Description("删除任务")]
        删除任务 = 0x05,
        /// <summary>
        /// 清空任务中所有动作
        /// </summary>
        [Description("清除任务")]
        清除任务 = 0x06,
        /// <summary>
        /// 开启串行任务队列
        /// </summary>
        [Description("开启任务队列")]
        开启任务队列 = 0x07,
        /// <summary>
        /// 暂停串行任务队列（等待当前任务执行完毕）
        /// </summary>
        [Description("暂停任务队列")]
        暂停任务队列 = 0x08,
        /// <summary>
        /// 暂停串行任务队列（不等待当前任务执行完毕，立刻停止）
        /// </summary>
        [Description("停止任务队列")]
        停止任务队列 = 0x09,
        /// <summary>
        /// 复位故障
        /// </summary>
        [Description("复位")]
        复位 = 0x10,
        /// <summary>
        /// 设备停下任何动作，并不能操作
        /// </summary>
        [Description("停止")]
        停止 = 0x11,
    }
}
