﻿using DWZB_Agv_Agreement.AgvAutoTest;
using DWZB_Agv_Agreement.Graph;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace DWZB_Agv_Agreement
{
    public partial class Form5 : Form
    {
        public Form5()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            try
            {

                IGraph graph = new DenseGraphImpl(AgvAutoTest_Biz.Instance.LocLst.Count, false);
                foreach (Bas_Route item in AgvAutoTest_Biz.Instance.RouteLst)
                {
                    int sIdx = AgvAutoTest_Biz.Instance.LocLst.FindIndex(x => x.LocNo == item.SLocNo);
                    int eIdx = AgvAutoTest_Biz.Instance.LocLst.FindIndex(x => x.LocNo == item.ELocNo);
                    graph.AddEdge(sIdx, eIdx);
                }
                int sLocIdx = AgvAutoTest_Biz.Instance.LocLst.FindIndex(x => x.LocNo == Convert.ToInt32(numericUpDown1.Value));
                int eLocIdx = AgvAutoTest_Biz.Instance.LocLst.FindIndex(x => x.LocNo == Convert.ToInt32(numericUpDown2.Value));
                ShortestPath testPath = new(graph, sLocIdx);
                if (testPath.HasPath(eLocIdx))
                {
                    List<int> vec = testPath.Path(eLocIdx);
                    string pathStr = string.Empty;
                    for (int i = 0; i < vec.Count; i++)
                    {
                        Console.WriteLine(AgvAutoTest_Biz.Instance.LocLst[vec[i]].LocNo);
                        pathStr += AgvAutoTest_Biz.Instance.LocLst[vec[i]].LocNo;
                        if (i == vec.Count - 1)
                        {
                            Console.WriteLine();
                        }
                        else
                        {
                            Console.WriteLine(" -> ");
                            pathStr += " -> ";
                        }
                    }
                    MessageBox.Show($"存在路径。【{pathStr}】");
                }
                else
                {
                    MessageBox.Show("不存在路径！！！");
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show($"查找路径发生异常：【{ex.Message}】【{ex.StackTrace}】");
            }
        }

        private void Form5_Load(object sender, EventArgs e)
        {
            AgvAutoTest_Biz.Instance.Init();
        }
    }
}
